// bcc32 -c -P -w apply.c
// cl /c /Tp apply.c

#include <ctype.h>
#include <stdio.h>

void    Apply(FILE* Out, const char* Template, const char **Args)
    {
    FILE* In;

    In  = fopen(Template, "r");
    if(In)
        {
        int c;

        while((c=fgetc(In)) != EOF)
            {
            if(c == '$')    /* if special character */
                {
                c   = fgetc(In);
                if(c == '$')
                    fputc(c, Out);
                else if(c >= '0' && c <= '9')
                    {
                    if(Args[c-'0'])
                        fputs(Args[c-'0'], Out);
                    }
                }
            else
                fputc(c, Out);
            }
        fclose(In);
        }
    }


/* handy wrapper function for real Apply()
 */
void    Apply(FILE* Out, const char*Template,
            const char*Arg0=0,
            const char*Arg1=0,
            const char*Arg2=0,
            const char*Arg3=0,
            const char*Arg4=0,
            const char*Arg5=0,
            const char*Arg6=0,
            const char*Arg7=0,
            const char*Arg8=0,
            const char*Arg9=0)
    {
    const char* Array[10];
    Array[0]        = Arg0;
    Array[1]        = Arg1;
    Array[2]        = Arg2;
    Array[3]        = Arg3;
    Array[4]        = Arg4;
    Array[5]        = Arg5;
    Array[6]        = Arg6;
    Array[7]        = Arg7;
    Array[8]        = Arg8;
    Array[9]        = Arg9;

    Apply(Out, Template, Array);
    }

